discussion/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('todolist/', include('todolist.urls'))
]

todolist/urls.py
from django.urls import path

from . import views

"""
path()
    Syntax: 
        path(route, view, name)
"""
app_name = "todolist"
urlpatterns = [
    # /todoitem route
    path('', views.index, name='index'),

    # /todoitem/<event_id> route
    path('event_item/<int:event_id>/', views.event_item, name='event_item'),

    # /todoitem/<todoitem_id> route
    path('todoitem/<int:todoitem_id>/', views.todoitem, name='viewtodoitem'),

    # /register route
    path('register/', views.register, name='register'),

    # /change_password route
    path('change_password/', views.change_password, name="change_password"),

    # login route
    path('login/', views.login_view, name="login"),

    # logout route
    path('logout/', views.logout_view, name="logout"),

    # add_task route
    path('add_task/', views.add_task, name="add_task"),

    path('<int:todoitem_id>/', views.todoitem, name="todoitem"),
    path('<int:todoitem_id>/edit/', views.update_task, name="update_task"),
    path('<int:todoitem_id>/delete', views.delete_task, name="delete_task"),

    # add_event route
    path('add_event/', views.add_event, name="add_event"),

    
]

todolist/models.py
from django.db import models
from django.contrib.auth.models import User

# Create your models here.
# Call Mode in models from django


class ToDoItem(models.Model):
    # add fields
    task_name = models.CharField(max_length=50)
    description = models.CharField(max_length=200)
    status = models.CharField(max_length=50, default="pending")
    date_created = models.DateTimeField('date created')
    user = models.ForeignKey(User, on_delete=models.CASCADE, default="")

class Event(models.Model):
    event_name = models.CharField(max_length=50)
    description = models.CharField(max_length=20)
    status = models.CharField(max_length=20, default="pending")
    date_created = models.DateTimeField('date created')
    user = models.ForeignKey(User, on_delete=models.CASCADE, default="")

todolist/forms.py
from django import forms

class LoginForm(forms.Form):
	username = forms.CharField(label="Username", max_length=20)
	password = forms.CharField(label="Password", max_length=20)

class AddTaskForm(forms.Form):
	task_name = forms.CharField(label="Task Name", max_length=50)
	description = forms.CharField(label="Description", max_length=200)

class UpdateTaskForm(forms.Form):
	task_name = forms.CharField(label="Task Name", max_length=50)
	description = forms.CharField(label="Description", max_length=200)

class AddEventForm(forms.Form):
	event_name = forms.CharField(label="Event Name", max_length=50)
	description = forms.CharField(label="Description", max_length=20)

todolist/views.py
from django.shortcuts import render, redirect, get_object_or_404
from django.http import HttpResponse
from django.template import loader
from django.contrib.auth.models import User
from django.contrib.auth import authenticate, login, logout
from django.forms.models import model_to_dict
from django.utils import timezone

# Local imports
from .models import ToDoItem, Event
from .forms import LoginForm, AddTaskForm, UpdateTaskForm, AddEventForm

# Create your views here.


def index(request):
    todoitem_list = ToDoItem.objects.filter(user_id=request.user.id)
    event_list = Event.objects.filter(user_id=request.user.id)
    context = {
        'todoitem_list': todoitem_list,
        'event_list': event_list
    }
    return render(request, "todolist/index.html", context)


def todoitem(request, todoitem_id):
    # retrieves the item object
    todoitem = get_object_or_404(ToDoItem, pk=todoitem_id)

    # response = "You are viewing the details of %s"
    return render(request, "todolist/todoitem.html", model_to_dict(todoitem))


def register(request):
    # Retrieves all users from the database using User model from Django
    # users now is an array of object that contains user information
    users = User.objects.all()
    is_user_registered = False

    # Context values are passed to other files, usually in the html file (In our context, it will be passed to register.html)
    context = {
        "is_user_registered": is_user_registered
    }

    for indiv_user in users:
        if indiv_user.username == "johndoe":
            is_user_registered = True
            break

    if is_user_registered == False:
        user_to_register = User()
        user_to_register.username = "johndoe"
        user_to_register.first_name = "John"
        user_to_register.last_name = "Doe"
        user_to_register.email = "john@mail.com"

        # Setter function for the password
        user_to_register.set_password("john1234")
        user_to_register.is_staff = False
        user_to_register.is_active = True

        user_to_register.save()

        context = {
            "first_name": user_to_register.first_name,
            "last_name": user_to_register.last_name
        }

    return render(request, "todolist/register.html", context)


def change_password(request):
    is_user_authenticated = False
    user = authenticate(username="johndoe", password="john1234")
    print(user)

    #
    if user is not None:
        authenticated_user = User.objects.get(username="johndoe")
        authenticated_user.set_password("johndoe1")
        authenticated_user.save()
        is_user_authenticated = True

    context = {
        "is_user_authenticated": is_user_authenticated
    }
    return render(request, "todolist/change_password.html", context)


def login_view(request):
    # username = "johndoe"
    # password = "johndoe1"
    # user = authenticate(username=username, password=password)

    context = {
        # "is_user_authenticated": False
    }

    if request.method == 'POST':

        form = LoginForm(request.POST)

        if form.is_valid() == False:
            # Returns a blank Login Form
            form = LoginForm()
        else:
            # Retrieve information from the Login Form
            username = form.cleaned_data['username']
            password = form.cleaned_data['password']
            user = authenticate(username=username, password=password)
            context = {
            "username": username,
            "password": password
            }

        if user is not None:
            # Saves the user id in the session using Django's Session framework
            login(request, user)
            return redirect("todolist:index")
        else:
            # Provide context with Error to conditionally render error message
            context = {
                "error": True
            }

    return render(request, "todolist/login.html", context)


def logout_view(request):
    # Removes the saved session upon login
    logout(request)
    return redirect("todolist:index")

def add_task(request):
    context = {}

    if request.method == 'POST':
        form = AddTaskForm(request.POST)

        if form.is_valid() == False:
            form = AddTaskForm()
        else:
            task_name = form.cleaned_data['task_name']
            description = form.cleaned_data['description']

            # Check the database if a task already exists
            duplicates = ToDoItem.objects.filter(task_name=task_name)

            # If todoitem does not contain anny duplicates
            if not duplicates:

                ToDoItem.objects.create(task_name=task_name, description=description, date_created=timezone.now(), user_id=request.user.id)

            else:
                context = {
                    "error": True
                }

    return render(request, "todolist/add_task.html", context)


def update_task(request, todoitem_id):
    todoitem = ToDoItem.objects.filter(pk=todoitem_id)

    context = {
        "user": request.username,
        "todoitem_id": todoitem_id,
        "task_name": todoitem[0].task_name,
        "description": todoitem[0].description,
        "status": todoitem[0].status
    }

    if request.method == 'POST':
        form = UpdateTaskForm(request.POST)

        if form.is_valid == False:
            form = UpdateTaskForm()
        else:
            task_name = form.cleaned_data['task_name']
            description = form.cleaned_data['description']
            status = form.cleaned_data['status']

            if todoitem:
                todoitem[0].task_name = task_name
                todoitem[0].description = description
                todoitem[0].status = status

                todoitem[0].save()
                return redirect("todoitem:index")

            else:
                context = {
                    "error": True
                }
    return render(request, "todolist/update_task.html", context)


def delete_task(request,todoitem_id):

    todoitem = ToDoItem.objects.filter(pk=todoitem_id).delete()
    return redirect("todolist:index")

def add_event(request):
    context = {}

    if request.method == 'POST':
        form = AddEventForm(request.POST)

        if form.is_valid() == False:
            form = AddEventForm()

        else:
            event_name = form.cleaned_data['event_name']
            description = form.cleaned_data['description']

            # Check if there are duplicates
            duplicates = Event.objects.filter(event_name=event_name)

            # If Event does not have anny duplicates in the database
            if not duplicates:
                Event.objects.create(event_name=event_name, description=description, date_created=timezone.now(), user_id=request.user.id)
            else:
                context = {
                    "error": True
                }
    return render(request, "todolist/add_event.html", context)

def event_item(request, event_id):
    event_item = get_object_or_404(Event, pk=event_id)
    return render(request, "todolist/event_item.html",model_to_dict(event_item))

todolist/templates/todolist/add_event.html
{% extends 'base.html' %}

{% block title %}Add Event{% endblock %}

{% block content %}
  <div class="container">
    <div class="row">
      <div class="col-6 offset-3">
        <h1 class="text-center my-3">Add An Event</h1>
        {% if error == True %}
          <p class="text-danger">Duplicate event found</p>
        {% endif %}
        <form action="{% url 'todolist:add_event' %}" method="post">
          {% csrf_token %}

          <div class="mb-3">
              <label for="event_name">Event Name: </label>
              <input class="form-control" id="event_name" type="text" name="event_name" value="{{ event_name }}" maxlength="50" required>
          </div>

          <div class="mb-3">
              <label for="description">Description: </label>
              <textarea class="form-control" name="description" value="{{ description }}" required></textarea>
          </div>

          <div class="text-center">
              <input class="btn btn-success" type="submit" value="Add Event">
          </div>

        </form>
      </div>
    </div>
  </div>
{% endblock %}

todolist/templates/todolist/add_task.html
{% extends 'base.html' %}

{% block title %}Add Task{% endblock %}

{% block content %}
  <div class="container">
    <div class="row">
      <div class="col-6 offset-3">
        <h1 class="text-center my-3">Add A Task</h1>
        {% if error == True %}
          <p class="text-danger">Duplicate task found</p>
        {% endif %}
        <form action="{% url 'todolist:add_task' %}" method="post">
          {% csrf_token %}

          <div class="mb-3">
              <label for="task_name">Task Name: </label>
              <input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
          </div>

          <div class="mb-3">
              <label for="description">Description: </label>
              <textarea class="form-control" name="description" value="{{ description }}" required></textarea>
          </div>

          <div class="text-center">
              <input class="btn btn-success" type="submit" value="Add Task">
          </div>

        </form>
      </div>
    </div>
  </div>
{% endblock %}

todolist/templates/todolist/change_password.html
{% if is_user_authenticated == False%}
<h1>Invalid User Credentials</h1>
<p>Check if the username and password is correct</p>
{% else %}
<h1>User Password Successfully Updated!</h1>
<p>The password has been successfully updated</p>
{% endif %}

todolist/templates/todolist/event_item.html
{% block content %}
<div class="text-center my-3">
	<h1>{{ event_name }}</h1>
	<h3>Description</h3>
	<p>{{ description }}</p>
	<h3>Status</h3>
	<p>{{ status }}</p>
	
	<button class="btn btn-warning mx-1 text-decoration-none">
		<a href="{% url 'todolist:index' %}" class="text-light text-decoration-none">Back To Index</a>
	</button>
	
</div>

{% endblock %}

todolist/templates/todolist/index.html
{% extends 'base.html' %}

{% block title %}Home{% endblock %}

{% block content %}
  {% if todoitem_list or event_list and not user.is_anonymous %}
    <h1 class="text-center my-3">Welcome {{user.first_name}} {{user.last_name}}!</h1>
    <div class="container">
      <div class="row">

        {% if todoitem_list %}
          <h3 class="text-center mb-3">My Tasks</h3>
            <ul class="list-group col-lg-2 offset-lg-5 text-center">
            {% for todoitem in todoitem_list %}
              <a
                href="{% url 'todolist:viewtodoitem' todoitem.id %}"
                class="text-decoration-none"
              >
                <li class="list-group-item">
                  {{ todoitem.task_name }}
                </li>
              </a>
            {% endfor %}
            </ul>

        {% else %}
          <p>No tasks have been created.</p>
        {% endif %}

        {% if event_list %}
          <h3 class="text-center mb-3">My Events</h3>
          <ul class="list-group col-lg-2 offset-lg-5 text-center">
            {% for event_item in event_list %}
              <a
                href="{% url 'todolist:event_item' event_item.id %}"
                class="text-decoration-none"
              >
                <li class="list-group-item">
                  {{ event_item.event_name }}
                </li>
              </a>
            {% endfor %}
          </ul>

        {% else %}
          <h3 class="text-center my-3">My Events 2</h3>
          <p class="text-center mb-3">No events have been created</p>
        {% endif %}
 
      </div>
    </div> 

  {% elif user.is_anonymous == True %}
    <h1 class="text-center">You are not authorized to access this page</h1>
    <p class="text-center">Kindly login <a href="{% url 'todolist:login' %}">here</a></p>
    {% else %}
    <p>No tasks have been created.</p>
    <p>No events have been created</p>
  {% endif %}
{% endblock %}

todolist/templates/todolist/login.html
{% extends 'base.html' %}

{% block title %}Login{% endblock %}

{% block content %}
	<div class="container">
	  <div class="row">
	    <div class="col-6 offset-3">
	      <h1 class="text-center my-3">Login</h1>
	      {% if error == True %}
	        <p class="text-danger">Invalid user credentials, please check your username and password</p>
	      {% endif %}
	      <form action="{% url 'todolist:login' %}" method="post">
	        <!-- This template tag provides protection against Cross Site Request Forgeries (CSRF) -->
	        <!-- CSRF occurs when a malicious website contains a link, a form button or some JavaScript that is intended to perform some action our website, using the credentials of a logged-in user -->
	        {% csrf_token %}

	        <div class="mb-3">
	            <label for="username">Username: </label>
	            <input class="form-control" id="username" type="text" name="username" value="{{ username }}" maxlength="20" required>
	        </div>

	        <div class="mb-3">
	            <label for="password">Password: </label>
	            <input class="form-control" id="password" type="password" name="password" value="{{ password }}" maxlength="20" required>
	        </div>

	        <div class="text-center">
	            <input class="btn btxn-success" type="submit" value="Login">
	        </div>

	      </form>
	    </div>
	  </div>
	</div>

{% endblock %}

{% if is_user_authenticated == False %}
	<h1>Something Went Wrong</h1>
	<p>Please contact your administrator or reset your password</p>
	<a href="{% url 'todolist:index' %}">Back to Index Page</a>
{% endif %}

todolist/templates/todolist/register.html
{% if is_user_registered == False %}
<h1>Duplicate User Found</h1>
<p>A duplicate user hasbeen found, user creation unsuccessful</p>
{% else %}
<h1>User Successfully Created</h1>
<p>
  The account for {{first_name}} {{last_name}} has been successfully created
</p>
{% endif %}

todolist/templates/todolist/todoitem.html
{% block content %}
<div class="text-center my-3">
	<h1>{{ task_name }}</h1>
	<h3>Description</h3>
	<p>{{ description }}</p>
	<h3>Status</h3>
	<p>{{ status }}</p>
	
	<button class="btn btn-primary mx-1 text-decoration-none">
		<a href="{% url 'todolist:update_task' id %}" class="text-light text-decoration-none">Edit Task</a>
	</button>

	<button class="btn btn-danger mx-1 text-decoration-none">
		<a href="{% url 'todolist:delete_task' id %}" class="text-light text-decoration-none">Delete Task</a>
	</button>

	<button class="btn btn-warning mx-1 text-decoration-none">
		<a href="{% url 'todolist:index' %}" class="text-light text-decoration-none">Back To Tasks</a>
	</button>
	
</div>

{% endblock %}

todolist/templates/todolist/update_task.html
{% extends 'base.html' %}

{% block title %}Update Task{% endblock %}

{% block content %}
  {% if user.is_anonymous == False %}
  <div class="container">
    <div class="row">
      <div class="col-6 offset-3">
        <h1 class="text-center my-3">Update Task</h1>
        {% if error == True %}
          <p class="text-danger">Task not found</p>
        {% endif %}
        <form action="{% url 'todolist:update_task' todoitem_id %}" method="post">
          {% csrf_token %}

          <div class="mb-3">
              <label for="task_name">Task Name: </label>
              <input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
          </div>

          <div class="mb-3">
              <label for="description">Description: </label>
              <textarea class="form-control" name="description" required>{{ description }}</textarea>
          </div>

          <div class="mb-3">
              <label for="status">Status: </label>
              <input class="form-control" id="status" type="text" name="status" value="{{ status }}" maxlength="50" required>
          </div>

          <div class="text-center">
              <input class="btn btn-success" type="submit" value="Update Task">
          </div>

        </form>
      </div>
    </div>
  </div>
  {% else %}
    <h1 class="text-center my-3">You are not authorized to access this page.</h1>
    <p class="text-center">Kindly login <a href="{% url 'todolist:login' %}">here</a></p>
  {% endif %}
{% endblock %}